package org.gcube.application.cms.plugins.reports;

import lombok.Data;
import org.gcube.application.cms.plugins.requests.EventExecutionRequest;
import org.gcube.application.cms.plugins.requests.StepExecutionRequest;
import org.gcube.application.geoportal.common.model.document.ProfiledDocument;

import java.util.ArrayList;
import java.util.List;

@Data
public class StepExecutionReport extends DocumentHandlingReport<StepExecutionRequest>{

    List<EventExecutionRequest> toTriggerEvents;

    List<StepExecutionRequest> cascadeSteps;


    public StepExecutionReport addToTriggerEvent(EventExecutionRequest req){
        if(toTriggerEvents==null) toTriggerEvents = new ArrayList<>();
        toTriggerEvents.add(req);
        return this;
    }


    public StepExecutionReport addCascadeStep(StepExecutionRequest req){
        if(cascadeSteps == null ) cascadeSteps = new ArrayList<>();
        cascadeSteps.add(req);
        return this;
    }
}
